﻿// Bookmarks.cs
//
// Aufruf über einen neuen Menüpunkt "Lesezeichen"
// im Untermenü "Projekt"
//
// Copyright by Frank Schöneck, 2011-2018
// letzte Änderung:
// V1.0.0, 29.11.2011, Frank Schöneck,	Projektbeginn
// V1.1.0, 04.06.2012, Frank Schöneck,	Eplan Versionsnummer in Bookmarks-Dateiname integriert.
// V1.1.1, 05.06.2012, Frank Schöneck,	Eplan Versionsnummer wird nun aus "EPLAN.exe" (ab V2.1) oder "W3U.exe" (bis 2.0) ermittelt.
// V2.0.0, 21.08.2012, Frank Schöneck,	Lesezeichen Tooltip zeigt nun den kompletten Pfad des Projektes an.
//										Es wird nun das vorhanden sein der Projekte getestet und ggf. das Lesezeichen grau dargestellt, das Lesezeichen bleibt aber weiter aktiv (geht im ListView nicht anders)
//										Neuer Menüpunkt 'Akualisieren' ins Kontextmenü eingebaut oder mit Taste 'F5'.
//										Menüpunkt "Lesezeichen" ist nun unter "Schließen" im Projekt-Menü gewandert. (Wegen Select-Versionen)
// V2.1.0, 08.10.2012, Frank Schöneck,	Lesezeichen können nun nach oben/unten verschoben werden.
// V3.0.0, 11.04.2013, Frank Schöneck,	Quellcode nach C# portiert.
//										Eplan Versionsnummer wird nun aus den Eplan Settings ausgelesen.
//										Der angezeigte Projektname kann geändert werden (Kontextmenü 'Umbenennen' oder mit Taste 'F2').
//										Projekte können nun schreibgeschützt werden (funktioniert erst ab der Eplan Platform V2.3).
//										Button für Kontextmenü entfernt, analog zu Eplan Platform V2.4.
//										Icons an Eplan Platform V2.4 angepasst.
//										Neue Buttons für "Lesezeichen hinzufügen" und "Löschen".
//										Navigator nutzt nun das EPLAN-Fenster als Inhaber Fenster.
// V3.0.1, 13.05.2013, Frank Schöneck,	Fensterposition optimiert.
// V3.0.2, 20.04.2015, Frank Schöneck,	Speichern der Settings verbessert, Anzeige des Tooltip vereinfacht/verbessert.
// V3.0.3, 28.07.2015, Frank Schöneck,	Menüpunkt "Lesezeichen" wird nun abhändig von "Verwaltung" eingefügt. (Wegen Select-Versionen)
// V3.0.4, 27.10.2016, Frank Schöneck,	Eplan Versionsnummer wird nun aus einem anderen Eplan Settings ausgelesen, damit der Bookmarks-Dateiname sich nicht mit jedem Hotfix ändert.
// V3.0.5, 21.06.2018, Frank Schöneck,	Speichern der Settings vereinfacht.
// V3.0.6, 21.06.2018, Frank Schöneck,	Fehlerbehandlung beim speichern der Settings eingefügt.
//
// für Eplan Electric P8, ab V2.6
//
using System;
using System.IO;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;
using Eplan.EplApi.ApplicationFramework;
using Eplan.EplApi.Scripting;
using Eplan.EplApi.Base;

public partial class frmLesezeichen : System.Windows.Forms.Form
{
    internal ContextMenuStrip ContextMenuStrip1;
    internal ToolStripMenuItem NeuToolStripMenuItem;
    internal ToolStripMenuItem ÖffnenToolStripMenuItem;
    internal ToolStripSeparator ToolStripSeparator1;
    internal ToolStripMenuItem LöschenToolStripMenuItem;
    private ToolStripMenuItem AktualisierenToolStripMenuItem;
    private ListView ListView;
    private ColumnHeader Projektname;
    internal Button btnListViewItemUp;
    internal Button btnListViewItemDown;
    internal ImageList ImageList1;
    private ToolStripMenuItem projektSchreibschutzToolStripMenuItem;
    private ToolStripMenuItem UmbenennenToolStripMenuItem;
    private Button btnLöschen;
    internal Button btnNeu;

    #region Vom Windows Form-Designer generierter Code

    /// <summary>
    /// Erforderliche Designervariable.
    /// </summary>
    private System.ComponentModel.IContainer components = null;

    /// <summary>
    /// Verwendete Ressourcen bereinigen.
    /// </summary>
    /// <param name="disposing">True, wenn verwaltete Ressourcen
    /// gelöscht werden sollen; andernfalls False.</param>
    protected override void Dispose(bool disposing)
    {
        if (disposing && (components != null))
        {
            components.Dispose();
        }
        base.Dispose(disposing);
    }

    /// <summary>
    /// Erforderliche Methode für die Designerunterstützung.
    /// Der Inhalt der Methode darf nicht mit dem Code-Editor
    /// geändert werden.
    /// </summary>
    private void InitializeComponent()
    {
        this.components = new System.ComponentModel.Container();
        this.ContextMenuStrip1 = new System.Windows.Forms.ContextMenuStrip(this.components);
        this.NeuToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
        this.ÖffnenToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
        this.projektSchreibschutzToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
        this.ToolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
        this.LöschenToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
        this.UmbenennenToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
        this.AktualisierenToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
        this.ListView = new System.Windows.Forms.ListView();
        this.Projektname = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
        this.ImageList1 = new System.Windows.Forms.ImageList(this.components);
        this.btnListViewItemUp = new System.Windows.Forms.Button();
        this.btnListViewItemDown = new System.Windows.Forms.Button();
        this.btnLöschen = new System.Windows.Forms.Button();
        this.btnNeu = new System.Windows.Forms.Button();
        this.ContextMenuStrip1.SuspendLayout();
        this.SuspendLayout();
        // 
        // ContextMenuStrip1
        // 
        this.ContextMenuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.NeuToolStripMenuItem,
            this.ÖffnenToolStripMenuItem,
            this.projektSchreibschutzToolStripMenuItem,
            this.ToolStripSeparator1,
            this.LöschenToolStripMenuItem,
            this.UmbenennenToolStripMenuItem,
            this.AktualisierenToolStripMenuItem});
        this.ContextMenuStrip1.Name = "ContextMenuStrip1";
        this.ContextMenuStrip1.RenderMode = System.Windows.Forms.ToolStripRenderMode.System;
        this.ContextMenuStrip1.Size = new System.Drawing.Size(205, 142);
        this.ContextMenuStrip1.Opening += new System.ComponentModel.CancelEventHandler(this.ContextMenuStrip1_Opening);
        // 
        // NeuToolStripMenuItem
        // 
        this.NeuToolStripMenuItem.Name = "NeuToolStripMenuItem";
        this.NeuToolStripMenuItem.Size = new System.Drawing.Size(204, 22);
        this.NeuToolStripMenuItem.Text = "Lesezeichen hi&nzufügen";
        this.NeuToolStripMenuItem.Click += new System.EventHandler(this.NeuToolStripMenuItem_Click);
        // 
        // ÖffnenToolStripMenuItem
        // 
        this.ÖffnenToolStripMenuItem.Name = "ÖffnenToolStripMenuItem";
        this.ÖffnenToolStripMenuItem.Size = new System.Drawing.Size(204, 22);
        this.ÖffnenToolStripMenuItem.Text = "Projekt &öffnen";
        this.ÖffnenToolStripMenuItem.Click += new System.EventHandler(this.ÖffnenToolStripMenuItem_Click);
        // 
        // projektSchreibschutzToolStripMenuItem
        // 
        this.projektSchreibschutzToolStripMenuItem.Name = "projektSchreibschutzToolStripMenuItem";
        this.projektSchreibschutzToolStripMenuItem.Size = new System.Drawing.Size(204, 22);
        this.projektSchreibschutzToolStripMenuItem.Text = "Projekt &Schreibgeschützt";
        this.projektSchreibschutzToolStripMenuItem.Click += new System.EventHandler(this.projektSchreibschutzToolStripMenuItem_Click);
        // 
        // ToolStripSeparator1
        // 
        this.ToolStripSeparator1.Name = "ToolStripSeparator1";
        this.ToolStripSeparator1.Size = new System.Drawing.Size(201, 6);
        // 
        // LöschenToolStripMenuItem
        // 
        this.LöschenToolStripMenuItem.Name = "LöschenToolStripMenuItem";
        this.LöschenToolStripMenuItem.Size = new System.Drawing.Size(204, 22);
        this.LöschenToolStripMenuItem.Text = "&Löschen";
        this.LöschenToolStripMenuItem.Click += new System.EventHandler(this.LöschenToolStripMenuItem_Click);
        // 
        // UmbenennenToolStripMenuItem
        // 
        this.UmbenennenToolStripMenuItem.Name = "UmbenennenToolStripMenuItem";
        this.UmbenennenToolStripMenuItem.ShortcutKeys = System.Windows.Forms.Keys.F2;
        this.UmbenennenToolStripMenuItem.Size = new System.Drawing.Size(204, 22);
        this.UmbenennenToolStripMenuItem.Text = "&Umbenennen";
        this.UmbenennenToolStripMenuItem.Click += new System.EventHandler(this.UmbenennenToolStripMenuItem_Click);
        // 
        // AktualisierenToolStripMenuItem
        // 
        this.AktualisierenToolStripMenuItem.Name = "AktualisierenToolStripMenuItem";
        this.AktualisierenToolStripMenuItem.ShortcutKeys = System.Windows.Forms.Keys.F5;
        this.AktualisierenToolStripMenuItem.Size = new System.Drawing.Size(204, 22);
        this.AktualisierenToolStripMenuItem.Text = "Aktualisieren";
        this.AktualisierenToolStripMenuItem.Click += new System.EventHandler(this.AktualisierenToolStripMenuItem_Click);
        // 
        // ListView
        // 
        this.ListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
        | System.Windows.Forms.AnchorStyles.Left)
        | System.Windows.Forms.AnchorStyles.Right)));
        this.ListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.Projektname});
        this.ListView.ContextMenuStrip = this.ContextMenuStrip1;
        this.ListView.FullRowSelect = true;
        this.ListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
        this.ListView.HideSelection = false;
        this.ListView.LabelEdit = true;
        this.ListView.Location = new System.Drawing.Point(0, 27);
        this.ListView.MultiSelect = false;
        this.ListView.Name = "ListView";
        this.ListView.ShowGroups = false;
        this.ListView.ShowItemToolTips = true;
        this.ListView.Size = new System.Drawing.Size(192, 385);
        this.ListView.SmallImageList = this.ImageList1;
        this.ListView.TabIndex = 0;
        this.ListView.UseCompatibleStateImageBehavior = false;
        this.ListView.View = System.Windows.Forms.View.Details;
        this.ListView.AfterLabelEdit += new System.Windows.Forms.LabelEditEventHandler(this.ListView_AfterLabelEdit);
        this.ListView.ItemActivate += new System.EventHandler(this.ListView_ItemActivate);
        this.ListView.SizeChanged += new System.EventHandler(this.ListView_SizeChanged);
        this.ListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ListView_KeyDown);
        this.ListView.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ListView_MouseDown);
        // 
        // Projektname
        // 
        this.Projektname.Text = "Projektname";
        this.Projektname.Width = 176;
        // 
        // ImageList1
        // 
        this.ImageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
        this.ImageList1.ImageSize = new System.Drawing.Size(16, 16);
        this.ImageList1.TransparentColor = System.Drawing.Color.Transparent;
        // 
        // btnListViewItemUp
        // 
        this.btnListViewItemUp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
        this.btnListViewItemUp.Enabled = false;
        this.btnListViewItemUp.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
        this.btnListViewItemUp.ForeColor = System.Drawing.SystemColors.ControlText;
        this.btnListViewItemUp.Location = new System.Drawing.Point(140, 2);
        this.btnListViewItemUp.Margin = new System.Windows.Forms.Padding(0);
        this.btnListViewItemUp.Name = "btnListViewItemUp";
        this.btnListViewItemUp.Size = new System.Drawing.Size(24, 22);
        this.btnListViewItemUp.TabIndex = 5;
        this.btnListViewItemUp.TabStop = false;
        this.btnListViewItemUp.UseVisualStyleBackColor = true;
        this.btnListViewItemUp.Click += new System.EventHandler(this.btnListViewItemUp_Click);
        this.btnListViewItemUp.MouseHover += new System.EventHandler(this.btnListViewItemUp_MouseHover);
        // 
        // btnListViewItemDown
        // 
        this.btnListViewItemDown.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
        this.btnListViewItemDown.Enabled = false;
        this.btnListViewItemDown.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
        this.btnListViewItemDown.ForeColor = System.Drawing.SystemColors.ControlText;
        this.btnListViewItemDown.Location = new System.Drawing.Point(163, 2);
        this.btnListViewItemDown.Name = "btnListViewItemDown";
        this.btnListViewItemDown.Size = new System.Drawing.Size(24, 22);
        this.btnListViewItemDown.TabIndex = 4;
        this.btnListViewItemDown.TabStop = false;
        this.btnListViewItemDown.UseVisualStyleBackColor = true;
        this.btnListViewItemDown.Click += new System.EventHandler(this.btnListViewItemDown_Click);
        this.btnListViewItemDown.MouseHover += new System.EventHandler(this.btnListViewItemDown_MouseHover);
        // 
        // btnLöschen
        // 
        this.btnLöschen.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
        this.btnLöschen.Enabled = false;
        this.btnLöschen.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
        this.btnLöschen.ForeColor = System.Drawing.SystemColors.ControlText;
        this.btnLöschen.Location = new System.Drawing.Point(117, 2);
        this.btnLöschen.Name = "btnLöschen";
        this.btnLöschen.Size = new System.Drawing.Size(24, 22);
        this.btnLöschen.TabIndex = 4;
        this.btnLöschen.TabStop = false;
        this.btnLöschen.UseVisualStyleBackColor = true;
        this.btnLöschen.Click += new System.EventHandler(this.btnLöschen_Click);
        this.btnLöschen.MouseHover += new System.EventHandler(this.btnLöschen_MouseHover);
        // 
        // btnNeu
        // 
        this.btnNeu.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
        this.btnNeu.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
        this.btnNeu.ForeColor = System.Drawing.SystemColors.ControlText;
        this.btnNeu.Location = new System.Drawing.Point(94, 2);
        this.btnNeu.Margin = new System.Windows.Forms.Padding(0);
        this.btnNeu.Name = "btnNeu";
        this.btnNeu.Size = new System.Drawing.Size(24, 22);
        this.btnNeu.TabIndex = 5;
        this.btnNeu.TabStop = false;
        this.btnNeu.UseVisualStyleBackColor = true;
        this.btnNeu.Click += new System.EventHandler(this.btnNeu_Click);
        this.btnNeu.MouseHover += new System.EventHandler(this.btnNeu_MouseHover);
        // 
        // frmLesezeichen
        // 
        this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
        this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
        this.ClientSize = new System.Drawing.Size(192, 407);
        this.ContextMenuStrip = this.ContextMenuStrip1;
        this.Controls.Add(this.btnListViewItemUp);
        this.Controls.Add(this.btnNeu);
        this.Controls.Add(this.btnLöschen);
        this.Controls.Add(this.btnListViewItemDown);
        this.Controls.Add(this.ListView);
        this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
        this.MaximizeBox = false;
        this.MinimizeBox = false;
        this.MinimumSize = new System.Drawing.Size(150, 200);
        this.Name = "frmLesezeichen";
        this.ShowIcon = false;
        this.ShowInTaskbar = false;
        this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
        this.Text = "Lesezeichen";
        this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.frmLesezeichen_FormClosing);
        this.Load += new System.EventHandler(this.frmLesezeichen_Load);
        this.ContextMenuStrip1.ResumeLayout(false);
        this.ResumeLayout(false);

    }

    public frmLesezeichen()
    {
        InitializeComponent();
    }

    #endregion

    //Bookmarks Datei Globale Variablen definieren
    private string sBookmarksDir = string.Empty;
    private string sBookmarksFileName = string.Empty;

    //Hauptmenü
    [DeclareMenu()]
    public void Lesezeichen_Menu()
    {
        Eplan.EplApi.Gui.Menu oMenu = new Eplan.EplApi.Gui.Menu();
        //Ist Menüpunkt "Verwaltung" vorhanden, wenn nicht über "Neu" einfügen
        uint menuID = oMenu.GetPersistentMenuId("Verwaltung...");
        if (menuID == 0)
        {
            //Menüpunkt über "Neu"
            oMenu.AddMenuItem("Lesezeichen-Navigator", "LesezeichenDialogShow", "Lesezeichen-Navigator ein- / ausschalten", 35001, 0, false, true);
        }
        else
        {
            //Menüpunkt unter "Verwaltung"
            oMenu.AddMenuItem("Lesezeichen-Navigator", "LesezeichenDialogShow", "Lesezeichen-Navigator ein- / ausschalten", 35103, 1, false, false);
        }
    }

    //Prüft ob Eplan gestartet wurde
    [DeclareEventHandler("Eplan.EplApi.OnMainStart")]
    public void MyEventEplanStart()
    {
        int iFormVisible = 0;
        Eplan.EplApi.Base.Settings oSettings = new Eplan.EplApi.Base.Settings();

        //War die Form beim letzten mal sichtbar?
        if (oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Visible"))
        {
            iFormVisible = oSettings.GetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Visible", 0);
        }

        //wenn ja (1) dann Form anzeigen
        if (iFormVisible == 1)
        {
            CommandLineInterpreter cmdLineItp = new CommandLineInterpreter();
            cmdLineItp.Execute("LesezeichenDialogShow");
        }
        return;
    }

    //Prüft ob Eplan beendet wird
    [DeclareEventHandler("Eplan.EplApi.OnMainEnd")]
    public void MyEventEplanEnd()
    {
        //Prüfen, ob Form angezeigt wird, wenn ja merken
        Eplan.EplApi.Base.Settings oSettings = new Eplan.EplApi.Base.Settings();
        if (oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Visible"))
        {
            if (FormIsLoaded("frmLesezeichen"))
            {
                oSettings.SetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Visible", 1, 0); //1 = Visible = True
            }
            else
            {
                oSettings.SetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Visible", 0, 0); //0 = Visible = False
            }
        }
        return;
    }

    //Action um die Form aufzurufen
    [DeclareAction("LesezeichenDialogShow")]
    public void LesezeichenDialogShow_action()
    {
        //Prüfen, ob Form bereits geladen, falls nicht, jetzt laden und anzeigen
        if (!FormIsLoaded("frmLesezeichen"))
        {
            //nutzt das EPLAN-Fenster als Inhaber Fenster
            Process oCurrent = Process.GetCurrentProcess();
            var ww = new WindowWrapper(oCurrent.MainWindowHandle);

            //Form laden
            frmLesezeichen frm = new frmLesezeichen();
            //Icon nachladen
            frm.btnNeu.Image = Image.FromFile(GetActualScriptPath + "Bookmarks_Icon_New.png");
            frm.btnLöschen.Image = Image.FromFile(GetActualScriptPath + "Bookmarks_Icon_Delete.png");
            frm.btnListViewItemUp.Image = Image.FromFile(GetActualScriptPath + "Bookmarks_Icon_Up.png");
            frm.btnListViewItemDown.Image = Image.FromFile(GetActualScriptPath + "Bookmarks_Icon_Down.png");
            //Icons für Projekt in ImageList laden
            Image icoProject = Image.FromFile(GetActualScriptPath + "Bookmarks_Icon_Prj.png");
            frm.ImageList1.Images.Add(icoProject);
            icoProject = Image.FromFile(GetActualScriptPath + "Bookmarks_Icon_Prj_RO.png");
            frm.ImageList1.Images.Add(icoProject);
            //Dialog anzeigen		
            frm.Show(ww); //mit EPLAN als Inhaber Fenster
        }
        else
        {
            Application.Exit(); //schon geladen deshalb beenden
        }
        return;
    }

    //Aktueller Pfad in dem das Script ausgeführt wird
    public string GetActualScriptPath
    {
        get
        {
            string sMyPath = PathMap.SubstitutePath("$(MD_SCRIPTS)") + "\\Bookmarks";
            //Pfad muss mit \ enden
            if (!sMyPath.EndsWith(@"\"))
            {
                sMyPath += @"\";
            }
            return sMyPath;
        }
    }

    //XML Datei einlesen
    private void XMLReader(string sFileName)
    {
        //MessageBox.Show("XML.Reader :" + sFileName);
        ListViewItem objListViewItem = new ListViewItem();

        //Wir benötigen einen XmlReader für das Auslesen der XML-Datei 
        XmlTextReader XMLReader = new XmlTextReader(sFileName);

        //Es folgt das Auslesen der XML-Datei 
        while (XMLReader.Read()) //Es sind noch Daten vorhanden 
        {
            //Welche Art von Daten liegt an? 
            switch (XMLReader.NodeType)
            {
                //Ein Element 
                case XmlNodeType.Element:
                    //wenn Lesezeichen
                    if (XMLReader.Name == "Lesezeichen")
                    {
                        //MessageBox.Show("Es folgt ein Element vom Typ " + XMLReader.Name);
                        //Alle Attribute (Name-Wert-Paare) abarbeiten 
                        if (XMLReader.AttributeCount > 0)
                        {
                            //Es sind noch weitere Attribute vorhanden 
                            objListViewItem = new ListViewItem();
                            while (XMLReader.MoveToNextAttribute()) //nächstes
                            {
                                if (XMLReader.Name == "Projektname")
                                {
                                    objListViewItem.Text = XMLReader.Value;
                                    //objListViewItem.ImageIndex = 0;
                                }
                                else if (XMLReader.Name == "Projektpfad")
                                {
                                    objListViewItem.SubItems.Add(XMLReader.Value);
                                    objListViewItem.ToolTipText = XMLReader.Value;
                                    //Prüfen ob Datei vorhanden, sonst ausgrauen
                                    if (!File.Exists(XMLReader.Value))
                                    {
                                        objListViewItem.ForeColor = System.Drawing.Color.Gray;
                                    }
                                }
                                else if (XMLReader.Name == "OpenMode")
                                {
                                    objListViewItem.SubItems.Add(XMLReader.Value);
                                }
                            }
                            //Icon für Projekt setzen
                            if (objListViewItem.SubItems[2].Text == "STANDARD")
                            {
                                objListViewItem.ImageIndex = 0;
                            }
                            else if (objListViewItem.SubItems[2].Text == "READONLY")
                            {
                                objListViewItem.ImageIndex = 1;
                            }
                            //Eintrag in Listview
                            ListView.Items.Add(objListViewItem);
                        }
                    }
                    break;
                //Ein Text 
                case XmlNodeType.Text:
                    MessageBox.Show("Es folgt ein Text: " + XMLReader.Value);
                    break;
                //Ein Kommentar 
                case XmlNodeType.Comment:
                    MessageBox.Show("Es folgt ein Kommentar: " + XMLReader.Value);
                    break;
            }

        }  //Weiter nach Daten schauen 
        XMLReader.Close();  //XMLTextReader schließen 
    }

    //XML Datei schreiben
    private void XMLWriter(string sFileName)
    {
        //Auswahl einer Kodierungsart für die Zeichenablage 
        System.Text.UnicodeEncoding enc = new System.Text.UnicodeEncoding();
        //XmlTextWriter-Objekt für unsere Ausgabedatei erzeugen: 
        XmlTextWriter XMLobj = new XmlTextWriter(sFileName, enc);

        //Formatierung: 4er-Einzüge verwenden 
        XMLobj.Formatting = Formatting.Indented;
        XMLobj.Indentation = 4;
        //Dann fangen wir mal an: 
        XMLobj.WriteStartDocument();
        //Beginn eines Elements "LesezeichenListe". Darin werden wir mehrere 
        //Elemente "Lesezeichen" unterbringen. 
        XMLobj.WriteStartElement("LesezeichenListe");
        //Listview abarbeiten
        foreach (ListViewItem itemRow in ListView.Items)
        {
            //Hier kommt das erste Element "Lesezeichen". Ein Lesezeichen hat 
            //in unserem einfachen Beispiel eine Nummer, einen Eintragtext und einen Odnernamen. 
            XMLobj.WriteStartElement("Lesezeichen"); //<Lesezeichen
            XMLobj.WriteAttributeString("Projektname", itemRow.Text);
            XMLobj.WriteAttributeString("Projektpfad", itemRow.SubItems[1].Text);
            XMLobj.WriteAttributeString("OpenMode", itemRow.SubItems[2].Text);
            XMLobj.WriteEndElement(); //Lesezeichen /> 
        }
        // Nachdem das Element "LesezeichenListe" zwei Elemente "Lesezeichen" 
        //erhalten hat, beenden wir die Ausgabe für "LesezeichenListe"... 
        XMLobj.WriteEndElement(); //</Lesezeichen> 
                                  // ... und schließen das XML-Dokument (und die Datei) 
        XMLobj.WriteEndDocument();
        XMLobj.Close();
    }

    //Form wird geladen
    private void frmLesezeichen_Load(object sender, EventArgs e)
    {
#if DEBUG
        //Globale Variablen mit Dateiname laden
        sBookmarksDir = Path.GetDirectoryName(Application.ExecutablePath);
        if (!sBookmarksDir.EndsWith(@"\"))
        {
            sBookmarksDir += @"\";
        }
        sBookmarksFileName = "schoeneck.xml";
#else
		//Globale Variablen mit Dateiname laden
		sBookmarksDir = GetActualScriptPath;
		sBookmarksFileName = SystemInformation.UserName + "_" + GetEplanVersion + ".xml";

		//Position und Größe aus Settings lesen
		Eplan.EplApi.Base.Settings oSettings = new Eplan.EplApi.Base.Settings();
		if (oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Top"))
		{
			this.Top = oSettings.GetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Top", 0);
		}
		if (oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Left"))
		{
			this.Left = oSettings.GetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Left", 0);
		}
		if (oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Height"))
		{
			this.Height = oSettings.GetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Height", 0);
		}
		if (oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Width"))
		{
			this.Width = oSettings.GetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Width", 0);
		}
#endif
        //Bookmarks einlesen
        BookmarksLesen();

        return;
    }

    //Form wird geschlossen
    private void frmLesezeichen_FormClosing(object sender, FormClosingEventArgs e)
    {
        //Einstellungen speichern
        SettingsWrite();
    }

    //Bookmarks speichern
    private void BookmarksSpeichern()
    {
        //Ordner ggf. anlegen
        if (!Directory.Exists(sBookmarksDir))
        {
            Directory.CreateDirectory(sBookmarksDir);
        }

        //XML-Datei schreiben
        XMLWriter(sBookmarksDir + sBookmarksFileName);

        return;
    }

    //Bookmarks lesen
    private void BookmarksLesen()
    {
        //Überprüfen ob Datei existiert, wenn nicht dann zurück
        if (!File.Exists(sBookmarksDir + sBookmarksFileName))
        {
            return;
        }
        else
        {
            ListView.Items.Clear();
            XMLReader(sBookmarksDir + sBookmarksFileName);
        }
        return;
    }

    //Einstellungen speichen
    private void SettingsWrite()
    {
#if !DEBUG
        try
        {
            Eplan.EplApi.Base.Settings oSettings = new Eplan.EplApi.Base.Settings();
            if (!oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Top"))
            {
                oSettings.AddNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Top",
                    new int[] { 0 },
                    new Range[] { },
                    ISettings.CreationFlag.Insert);
            }
            oSettings.SetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Top", this.Top, 0);

            if (!oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Left"))
            {
                oSettings.AddNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Left",
                    new int[] { 0 },
                    new Range[] { },
                    ISettings.CreationFlag.Insert);
            }
            oSettings.SetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Left", this.Left, 0);

            if (!oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Visible"))
            {
                oSettings.AddNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMLOCATION.Visible",
                    new int[] { 0 },
                    new Range[] { },
                    ISettings.CreationFlag.Insert);
            }

            if (!oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Height"))
            {
                oSettings.AddNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Height",
                    new int[] { 0 },
                    new Range[] { },
                    ISettings.CreationFlag.Insert);
            }
            oSettings.SetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Height", this.Height, 0);

            if (!oSettings.ExistSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Width"))
            {
                oSettings.AddNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Width",
                    new int[] { 0 },
                    new Range[] { },
                    ISettings.CreationFlag.Insert);
            }
            oSettings.SetNumericSetting("USER.SCRIPTS.BOOKMARKS.FORMSIZE.Width", this.Width, 0);
        }
        catch (BaseException exc)
        {
            String strMessage = exc.Message;
            MessageBox.Show("Exception: " + strMessage, "Lesezeichen, Fehler SettingsWrite", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

#endif
        //Bookmarks speichern
        BookmarksSpeichern();

        return;
    }

    //Prüft, ob eine bestimmte Form bereits geladen ist und gibt im Erfolgsfall True zurück
    public bool FormIsLoaded(string sName)
    {
        bool bResult = false;
        //alle geöffneten Forms durchlauden
        foreach (Form oForm in Application.OpenForms)
        {
            if (oForm.Name.ToLower() == sName.ToLower())
            {
                bResult = true;
                break;
            }
        }
        return (bResult);
    }

    //Projekt öffnen
    private void ProjektÖffnen()
    {
        Cursor.Current = Cursors.WaitCursor;

        if (ListView.SelectedItems.Count > 0)
        {
            string sProjectName = ListView.SelectedItems[0].Text;
            string sProjectPath = ListView.SelectedItems[0].SubItems[1].Text;
            string sProjectOpenMode = ListView.SelectedItems[0].SubItems[2].Text;
#if DEBUG
            MessageBox.Show(sProjectPath);
#else
			CommandLineInterpreter cmdLineItp = new CommandLineInterpreter();
			ActionCallingContext ACC = new ActionCallingContext();
			ACC.AddParameter("Project", sProjectPath);
			ACC.AddParameter("OpenMode", sProjectOpenMode);
			cmdLineItp.Execute("ProjectOpen", ACC);
#endif
        }
        Cursor.Current = Cursors.Default;
        return;
    }

    //Eplan Version ermitteln
    private string GetEplanVersion
    {
        get
        {
            Settings oSettings = new Settings();
            string major = string.Empty;
            string minor = string.Empty;
            string servicepack = string.Empty;
            string build = string.Empty;

            if (oSettings.ExistSetting("USER.SYSTEM.VERSION.complete"))
            {
                major = oSettings.GetStringSetting("USER.SYSTEM.VERSION.major", 0);
                minor = oSettings.GetStringSetting("USER.SYSTEM.VERSION.minor", 0);
                servicepack = oSettings.GetStringSetting("USER.SYSTEM.VERSION.servicepack", 0);
                //build = oSettings.GetStringSetting("USER.SYSTEM.VERSION.build", 0);
            }

            return major + "." + minor + "." + servicepack;
        }
    }

    //Verschiebt den aktuell selektierten Eintrag um eine Position nach oben
    public bool lvItem_Up(ListView sender)
    {
        if (sender.SelectedItems.Count == 1)
        {
            //aktuellen Eintrag und Position merken
            ListViewItem oItem = sender.SelectedItems[0];
            int index = oItem.Index;
            if (index > 0)
            {
                //jetzt den markierten Eintrag löschen
                sender.SelectedItems[0].Remove();

                //und den "gemerkten" Eintrag eine Position weiter oben einfügen
                sender.Items.Insert(index - 1, oItem);

                //Eintrag wieder selektieren
                oItem.Selected = true;
                oItem.EnsureVisible();
                oItem.Focused = true;

                return true;
            }
        }
        return false;
    }

    //Verschiebt den aktuell selektierten Eintrag um eine Position nach unten
    public bool lvItem_Down(ListView sender)
    {
        if (sender.SelectedItems.Count == 1)
        {
            //aktuellen Eintrag und Position merken
            ListViewItem oItem = sender.SelectedItems[0];
            int index = oItem.Index;
            if (index < sender.Items.Count - 1)
            {
                //jetzt den markierten Eintrag löschen
                sender.SelectedItems[0].Remove();

                //und den "gemerkten" Eintrag eine Position weiter oben einfügen
                sender.Items.Insert(index + 1, oItem);

                //Eintrag wieder selektieren
                oItem.Selected = true;
                oItem.EnsureVisible();
                oItem.Focused = true;

                return true;
            }
        }
        return false;
    }

    //Listview: Nach Eintrag Ändernung
    private void ListView_AfterLabelEdit(object sender, LabelEditEventArgs e)
    {
        //Überprüfen ob Label leer oder null ist 
        if (e.Label == "" || e.Label == null)
        {
            // Abbrechen des Event und zurücksetzen des Label in Originalzustand
            e.CancelEdit = true;
            return;
        }

        //Speichern auslösen
        BookmarksSpeichern();

        return;
    }

    //Listview: Eintrag aktivieren
    private void ListView_ItemActivate(object sender, EventArgs e)
    {
        //Projekt öffnen
        ProjektÖffnen();
        return;
    }

    //Listview: Taste gedrückt
    private void ListView_KeyDown(object sender, KeyEventArgs e)
    {
        switch (e.KeyData)
        {
            case Keys.F2:
                //Zelle bearbeiten
                UmbenennenToolStripMenuItem_Click(sender, e);
                break;
            case Keys.F5:
                //Ansicht aktualisieren
                AktualisierenToolStripMenuItem_Click(sender, e);
                break;
            case (Keys.Control | Keys.L):
                //Auf STRG+L reagieren: Wenn sichtbar dann Lesezeichen beenden
                if (FormIsLoaded("frmLesezeichen"))
                {
                    Application.Exit();
                }
                break;
        }
        return;
    }

    //Listview: Maus-Taste gedrückt
    private void ListView_MouseDown(object sender, MouseEventArgs e)
    {
        //ContextMenü & Buttons konfigurieren
        ListViewItem Item;
        Item = ListView.GetItemAt(e.Location.X, e.Location.Y); // Eintrag ermitteln...
        if (!(Item == null)) // Es wurde ein Eintrag ausgewählt
        {
            ÖffnenToolStripMenuItem.Enabled = true;
            LöschenToolStripMenuItem.Enabled = true;
            projektSchreibschutzToolStripMenuItem.Enabled = true;

            if (Item.SubItems[2].Text == "READONLY")
            {
                projektSchreibschutzToolStripMenuItem.Checked = true;
            }
            else if (Item.SubItems[2].Text == "STANDARD")
            {
                projektSchreibschutzToolStripMenuItem.Checked = false;
            }

            btnListViewItemDown.Enabled = true;
            btnListViewItemUp.Enabled = true;
            btnLöschen.Enabled = true;
        }
        else // Es wurde kein Eintrag ausgewählt
        {
            ÖffnenToolStripMenuItem.Enabled = false;
            LöschenToolStripMenuItem.Enabled = false;
            projektSchreibschutzToolStripMenuItem.Enabled = false;
            projektSchreibschutzToolStripMenuItem.Checked = false;

            btnListViewItemDown.Enabled = false;
            btnListViewItemUp.Enabled = false;
            btnLöschen.Enabled = false;
        }
        return;
    }

    //Listview: Größenänderung mitmachen
    private void ListView_SizeChanged(object sender, EventArgs e)
    {
        ListView.Columns[0].Width = (ListView.Width - 5);
        return;
    }

    //Kontextmenü 'Projekt öffnen'
    private void ÖffnenToolStripMenuItem_Click(object sender, EventArgs e)
    {
        //Projekt öffnen
        ProjektÖffnen();
        return;
    }

    //Kontextmenü 'Umbenennen (F2)'
    private void UmbenennenToolStripMenuItem_Click(object sender, EventArgs e)
    {
        //Zelle bearbeiten
        if (this.ListView.SelectedItems.Count == 1)
        {
            this.ListView.SelectedItems[0].BeginEdit();
            return;
        }
    }

    //Kontextmenü 'Aktualisieren (F5)'
    private void AktualisierenToolStripMenuItem_Click(object sender, EventArgs e)
    {
        //Bookmarks neu einlesen
        BookmarksLesen();
        return;
    }

    //Lesezeichen hinzufügen
    private void NeuToolStripMenuItem_Click(object sender, EventArgs e)
    {
        string sProjectname;
        string sProjectpath;
        string sProjectOpenMode;
        ListViewItem objListViewItem = null;
        sProjectname = PathMap.SubstitutePath("$(PROJECTNAME)");
        sProjectpath = PathMap.SubstitutePath("$(PROJECTPATH)").Replace(".edb", ".elk");
        sProjectOpenMode = "STANDARD";
        objListViewItem = new ListViewItem();
        objListViewItem.Text = sProjectname;
        objListViewItem.ImageIndex = 0;
        objListViewItem.ToolTipText = sProjectpath;
        objListViewItem.SubItems.Add(sProjectpath);
        objListViewItem.SubItems.Add(sProjectOpenMode);

        //Eintrag in Listview
        ListView.Items.Add(objListViewItem);

        //Speichern auslösen
        BookmarksSpeichern();

        return;
    }

    //Lesezeichen entfernen
    private void LöschenToolStripMenuItem_Click(object sender, EventArgs e)
    {
        ListView.SelectedItems[0].Remove();

        //Speichern auslösen
        BookmarksSpeichern();

        return;
    }

    //Eintrag eine Position nach oben schieben
    private void btnListViewItemUp_Click(object sender, EventArgs e)
    {
        lvItem_Up(ListView);

        //Speichern auslösen
        BookmarksSpeichern();

        return;
    }

    //Tooltip für Lesezeichen nach oben verschieben
    private void btnListViewItemUp_MouseHover(object sender, EventArgs e)
    {
        ToolTip myToolTip = new ToolTip();
        myToolTip.SetToolTip(btnListViewItemUp, "Lesezeichen nach oben verschieben");
        return;
    }

    //Eintrag um eine Position nach unten schieben
    private void btnListViewItemDown_Click(object sender, EventArgs e)
    {
        lvItem_Down(ListView);

        //Speichern auslösen
        BookmarksSpeichern();

        return;
    }

    //Tooltip für Lesezeichen nach unten verschieben
    private void btnListViewItemDown_MouseHover(object sender, EventArgs e)
    {
        ToolTip myToolTip = new ToolTip();
        myToolTip.SetToolTip(btnListViewItemDown, "Lesezeichen nach unten verschieben");
        return;
    }

    //Projekt Schreibschutz Ein-/Ausschalten
    private void projektSchreibschutzToolStripMenuItem_Click(object sender, EventArgs e)
    {
        if (ListView.SelectedItems.Count > 0)
        {
            string sProjectOpenMode = ListView.SelectedItems[0].SubItems[2].Text;
            if (sProjectOpenMode == "STANDARD")
            {
                ListView.SelectedItems[0].SubItems[2].Text = "READONLY";
                ListView.SelectedItems[0].ImageIndex = 1;
            }
            else if (sProjectOpenMode == "READONLY")
            {
                ListView.SelectedItems[0].SubItems[2].Text = "STANDARD";
                ListView.SelectedItems[0].ImageIndex = 0;
            }
        }

        //Bookmarks speichern
        BookmarksSpeichern();

        return;
    }

    //Kontextmenü öffnen
    private void ContextMenuStrip1_Opening(object sender, System.ComponentModel.CancelEventArgs e)
    {
        if (ListView.SelectedItems.Count != 0)
        {
            if (ListView.SelectedItems[0].SubItems[2].Text == "READONLY")
            {
                projektSchreibschutzToolStripMenuItem.Checked = true;
            }
            else if (ListView.SelectedItems[0].SubItems[2].Text == "STANDARD")
            {
                projektSchreibschutzToolStripMenuItem.Checked = false;
            }
            ÖffnenToolStripMenuItem.Enabled = true;
            LöschenToolStripMenuItem.Enabled = true;
            UmbenennenToolStripMenuItem.Enabled = true;
            projektSchreibschutzToolStripMenuItem.Enabled = true;
        }
        else
        {
            ÖffnenToolStripMenuItem.Enabled = false;
            LöschenToolStripMenuItem.Enabled = false;
            UmbenennenToolStripMenuItem.Enabled = false;
            projektSchreibschutzToolStripMenuItem.Enabled = false;
        }
        ContextMenuStrip1.Show(Control.MousePosition);
        return;

    }

    //Button: Lesezeichen hinzufügen
    private void btnNeu_Click(object sender, EventArgs e)
    {
        NeuToolStripMenuItem_Click(sender, e);
    }

    //Tooltip für Lesezeichen hinzufügen
    private void btnNeu_MouseHover(object sender, EventArgs e)
    {
        ToolTip myToolTip = new ToolTip();
        myToolTip.SetToolTip(btnNeu, "Lesezeichen hinzufügen");
        return;
    }

    //Button: Lesezeichen löschen
    private void btnLöschen_Click(object sender, EventArgs e)
    {
        LöschenToolStripMenuItem_Click(sender, e);
    }

    //Tooltip für Lesezeichen löschen
    private void btnLöschen_MouseHover(object sender, EventArgs e)
    {
        ToolTip myToolTip = new ToolTip();
        myToolTip.SetToolTip(btnLöschen, "Lesezeichen löschen");
        return;
    }

}

//Um das EPLAN-Fenster als Inhaber Fenster zu ermitteln
public class WindowWrapper : System.Windows.Forms.IWin32Window
{
    public WindowWrapper(IntPtr handle)
    {
        _hwnd = handle;
    }

    public IntPtr Handle
    {
        get { return _hwnd; }
    }
    private IntPtr _hwnd;
}
